#pragma warning(disable:4786)
#include <stdio.h>
#include "OsiClpSolverInterface.hpp"
#include "OsiGlpkSolverInterface.hpp"
#include "cplex_register.h"
#include "OsiCpxSolverInterface.hpp"

#include "test1.h"
#include "test2.h"
#include "test3.h"
#include "test4.h"
#include "test5.h"
#include "test6.h"
#include "test7.h"
#include "test8.h"
#include "test9.h"
#include "test10.h"

#include <vector>

typedef bool (*TestFunction)(OsiSolverInterface*, const char*);

int main()
{
	OsiSolverInterface *s = NULL;
	int i;
	FILE *log = fopen("test/results.log", "w");

	bool ret = true;

	std::vector<std::pair<TestFunction, const char*> > test_functions;	
	test_functions.push_back(std::pair<TestFunction, const char*>(&test1_solve, "test1"));
	test_functions.push_back(std::pair<TestFunction, const char*>(&test2_solve, "test2"));
	test_functions.push_back(std::pair<TestFunction, const char*>(&test3_solve, "test3"));
	test_functions.push_back(std::pair<TestFunction, const char*>(&test4_solve, "test4"));
	test_functions.push_back(std::pair<TestFunction, const char*>(&test5_solve, "test5"));
	test_functions.push_back(std::pair<TestFunction, const char*>(&test6_solve, "test6"));
	test_functions.push_back(std::pair<TestFunction, const char*>(&test7_solve, "test7"));
	test_functions.push_back(std::pair<TestFunction, const char*>(&test8_solve, "test8"));
	test_functions.push_back(std::pair<TestFunction, const char*>(&test9_solve, "test9"));
	test_functions.push_back(std::pair<TestFunction, const char*>(&test10_solve, "test10"));

	for (i = 0; i < test_functions.size(); ++i) {
		s = new OsiClpSolverInterface();
		bool test = test_functions[i].first(s, "clp");
		if (!test)
			fprintf(log, "%s(clp) fail\n", test_functions[i].second);
		ret = ret && test;
		delete s;
	}

	for (i = 0; i < test_functions.size(); ++i) {
		s = new OsiGlpkSolverInterface();
		bool test = test_functions[i].first(s, "glpk");
		if (!test)
			fprintf(log, "%s(glpk) fail\n", test_functions[i].second);
		ret = ret && test;
		delete s;
	}

	registerCplex();
	for (i = 0; i < test_functions.size(); ++i) {
		s = new OsiCpxSolverInterface();
		bool test = test_functions[i].first(s, "cpx");
		if (!test)
			fprintf(log, "%s(cpx) fail\n", test_functions[i].second);
		ret = ret && test;
		delete s;
	}

	fclose(log);

	return ret;
}
